/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoCorte;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoCorte;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoCorteController")
@Scope("prototype")
public class BusquedaTipoCorteController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoCorte> plwTipoCorte;
    private MyListbox tipoCorteList;
    private Paging pagingTipoCorte;
    private Textbox txtNome;

    public Paging getPagingTipoCorte() {
        return pagingTipoCorte;
    }

    public void setPagingTipoCorte(Paging pagingTipoCorte) {
        this.pagingTipoCorte = pagingTipoCorte;
    }

    public MyListbox getTipoCorteList() {
        return tipoCorteList;
    }

    public void setTipoCorteList(MyListbox tipoCorteList) {
        this.tipoCorteList = tipoCorteList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoCorteList.setItemRenderer(new RenderTipoCorte());
        tipoCorteList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoCorte a = (TipoCorte) tipoCorteList.getSelected();
                verTipoCorte(a);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTipoCorte(TipoCorte a) {
        if (a == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoCorte", a);
        args.put("tipoCorteList", tipoCorteList);

        openWindow("/gui/catalogos/editarTipoCorte.zul",
                Labels.getLabel("editarTipoCorteController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoCorte> tipoCorteBusqueda =
                new HibernateSearchObject<TipoCorte>(TipoCorte.class,
                pagingTipoCorte.getPageSize());

        tipoCorteBusqueda.addFilterLike("desctipo",
                "%" + txtNome.getText().trim().concat("%"));

        tipoCorteBusqueda.addSortAsc("desctipo");
        tipoCorteBusqueda.addFilterEqual("activo", Boolean.TRUE);
        tipoCorteBusqueda.addFilterNotEqual("tipocorteId", -1);

        plwTipoCorte.init(tipoCorteBusqueda, tipoCorteList, pagingTipoCorte);

        if (tipoCorteList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaArticuloController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoCorte(new TipoCorte());
    }
}
